############################################################
#
# type definition pro_declaration_component_altlogrotate
#
# RESPONSIBLE: Charles Loomis <charles.loomis@cern.ch>
#
# AUTHOR: Charles Loomis <charles.loomis@cern.ch>
#
# VERSION : 0.0.3
#
############################################################

declaration template pro_declaration_component_altlogrotate;

include pro_declaration_structures;
include pro_declaration_types;

define type structure_scripts = {
	"prerotate"   ? string
	"postrotate"  ? string
	"firstaction" ? string
	"lastaction"  ? string
};

define type structure_create_params = {
        "mode"  : string with match(self, '0[0-7]{3,3}')
        "owner" : string
        "group" : string
};

define type structure_logrot = {
	"pattern"         ? string
	"global"          ? boolean

	"include"         ? string

        "compress"        ? boolean
        "copy"            ? boolean
        "copytruncate"    ? boolean
	"delaycompress"   ? boolean
	"ifempty"         ? boolean
	"missingok"       ? boolean
	"sharedscripts"   ? boolean

        "compresscmd"     ? string
        "uncompresscmd"   ? string
        "compressext"     ? string
        "compressoptions" ? string

        "create"          ? boolean
        "createparams"    ? structure_create_params

        "extension"       ? string

	"mail"            ? type_email
	"nomail"          ? boolean
	"mailselect"      ? string with match(self, 'first|last')

	"olddir"          ? string
	"noolddir"        ? boolean

	"rotate"          ? long with (self>=0)
	"start"           ? long with (self>=0)

	"size"            ? string with match(self, '\d+[kM]?')

	"taboo_replace"   ? boolean
	"tabooext"        ? string[] 

	"frequency"       ? string with match(self, 'daily|weekly|monthly')

	"scripts"         ? structure_scripts
};

define type component_altlogrotate = {
	include structure_component
	"configFile" : string
        "configDir"  : string
        "entries"    ? structure_logrot{} with {tbl = self;
                                                exists(tbl["global"]);} 
};

type "/software/components/altlogrotate" = component_altlogrotate;


